// RPCClientCPP.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include "TimXmlRpc.h"

#define MATH_DEFAULT             0
#define MATH_INVERSE             1
#define MATH_SQUARE              2
#define MATH_INVERSE_SQUARE      3
#define MATH_SQUARE_ROOT         4
#define MATH_INVERSE_SQUARE_ROOT 5

void main(int argc, char* argv[])
{
    XmlRpcValue args, result;

    // Pass arguments here
    args[0] = MATH_DEFAULT;

	// Setup a connection with the XML-RPC server endpoint
	XmlRpcClient Connection("http://localhost:8080");
	Connection.setIgnoreCertificateAuthority();

    // Make the call to the XML-RPC Java webserver.
	if (! Connection.execute(
        "MathComputation.ComputePi", 
        args, 
        result)) 
    {
        // Something went wrong
		std::cout << Connection.getError();
		return;
	}

	// Retrieve the return value from the call
    // Check if the return type is the same as expected
    if (result.getType() != XmlRpcValue::TypeDouble) 
    {
		std::cout << "Expecting Double.";
		return;
	}

    // Get the result from the call in the form you want
    double pi = (double)result;

    std::cout.precision(15);
    std::cout << pi;
}

